// A Bison parser, made by GNU Bison 3.0.5-702c.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2013 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   vcsn::detail::dot::lex

// First part of user declarations.

#line 39 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:412

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

#include "parse.hh"

// User implementation prologue.

#line 53 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:420
// Unqualified %code blocks.
#line 83 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:421

#include <cassert>
#include <vcsn/algos/edit-automaton.hh>
#include <vcsn/misc/echo.hh>

#ifdef __GNUC
# pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
# pragma GCC diagnostic ignored "-Wsuggest-attribute=const"
#endif

  namespace vcsn
  {
    namespace detail
    {
      namespace dot
      {
        static std::ostream&
        operator<<(std::ostream& o, const sem_type::states_t ss)
        {
          bool first = true;
          o << '{';
          for (auto s: ss)
            {
              if (!first)
                o << ", ";
              o << s;
              first = false;
            }
          return o << '}';
        }

        static std::ostream&
        operator<<(std::ostream& o, const sem_type::transitions_t ts)
        {
          bool first = true;
          o << '{';
          for (auto t: ts)
            {
              if (!first)
                o << ", ";
              o << t.first << "->" << t.second;
              first = false;
            }
          return o << '}';
        }
      }
    }

    /// Run Stm, and bounces exceptions into parse errors at Loc.
#define TRY(Loc, Stm)                           \
    try                                         \
      {                                         \
        Stm;                                    \
      }                                         \
    catch (std::exception& e)                   \
      {                                         \
        error(Loc, e.what());                   \
        YYERROR;                                \
      }
  }

#line 117 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:421


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyempty = true)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 11 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:487
namespace vcsn { namespace detail { namespace dot {
#line 203 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:487

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (driver& driver__yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver_ (driver__yyarg)
  {}

  parser::~parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
    value = other.value;
  }


  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  inline
  parser::basic_symbol<Base>::~basic_symbol ()
  {
  }

  template <typename Base>
  inline
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
    value = s.value;
    location = s.location;
  }

  // by_type.
  inline
  parser::by_type::by_type ()
     : type (empty)
  {}

  inline
  parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.type = empty;
  }

  inline
  int
  parser::by_type::type_get () const
  {
    return type;
  }


  // by_state.
  inline
  parser::by_state::by_state ()
    : state (empty)
  {}

  inline
  parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.state = empty;
  }

  inline
  parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  parser::symbol_number_type
  parser::by_state::type_get () const
  {
    return state == empty ? 0 : yystos_[state];
  }

  inline
  parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
    value = that.value;
    // that is emptied.
    that.type = empty;
  }

  inline
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YYUSE (yysym.type_get ());
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
    {
            case 15: // ID

#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.string); }
#line 437 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 19: // stmt_list
//-
//-#line 177 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.states); }
//-#line 444 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 20: // stmt

#line 177 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.states); }
#line 451 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 22: // attr_list
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 458 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 23: // attr_list.opt
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 465 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 24: // attr_assign
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 472 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 25: // a
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 479 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 26: // a_list.1
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 486 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 29: // a_list.0

#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.string); }
#line 493 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 30: // nodes

#line 177 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.states); }
#line 500 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 31: // path

#line 306 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.transitions) /* << " (states: " << $<states>$ << ')' */; }
#line 507 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 32: // edge_stmt

#line 177 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.states); }
#line 514 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 33: // node_stmt
//-
//-#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
//-        { debug_stream() << (yysym.value.string); }
//-#line 521 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
//-        break;

      case 34: // node_id

#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.string); }
#line 528 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 35: // subgraph

#line 177 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.states); }
#line 535 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;

      case 36: // id.opt

#line 173 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:630
        { debug_stream() << (yysym.value.string); }
#line 542 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:630
        break;


      default:
        break;
    }
    yyo << ')';
  }
#endif

  inline
  void
  parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yylhs)
  {
    int yyr = yypgoto_[yylhs - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yylhs - yyntokens_];
  }

  inline bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::parse ()
  {
    /// Whether yyla contains a lookahead.
    bool yyempty = true;

    // State.
    int yyn;
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// $$ and @$.
    stack_symbol_type yylhs;

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    // User initialization code.
    #line 149 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:740
{
  yyla.location = driver_.location_;
}

#line 665 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:740

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULL, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyempty)
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver_));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
        yyempty = false;
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Discard the token being shifted.
    yyempty = true;

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
    /* If YYLEN is nonzero, implement the default value of the action:
       '$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYLHS.VALUE to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yylhs.value = yystack_[yylen - 1].value;
    else
      yylhs.value = yystack_[0].value;

    // Compute the default @$.
    {
      slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
      YYLLOC_DEFAULT (yylhs.location, slice, yylen);
    }

    // Perform the reduction.
    YY_REDUCE_PRINT (yyn);
    try
      {
        switch (yyn)
          {
  case 2:
#line 185 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
  }
#line 778 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 3:
#line 190 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { (yylhs.value.states).clear(); }
#line 784 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 4:
#line 192 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    // Preserve the set of states.
    std::swap((yylhs.value.states), (yystack_[2].value.states));
    for (auto s: (yystack_[1].value.states))
      (yylhs.value.states).emplace_back(std::move(s));
  }
#line 795 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 5:
#line 202 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    (yylhs.value.states).emplace_back(std::move((yystack_[0].value.string)));
  }
#line 803 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 6:
#line 206 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.states), (yystack_[0].value.states));
  }
#line 811 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 7:
//-#line 210 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
//-    {
//-  }
//-#line 818 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
//-    break;

  case 8:
#line 213 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
  }
#line 825 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 9:
#line 216 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.states), (yystack_[0].value.states));
  }
#line 833 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 10:
//-#line 222 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
//-    {}
//-#line 839 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
//-    break;

  case 11:
//-#line 223 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
//-    {}
//-#line 845 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
//-    break;

  case 12:
#line 224 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {}
#line 851 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 13:
#line 229 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.string), (yystack_[2].value.string).get().empty() ? (yystack_[0].value.string) : (yystack_[2].value.string));
  }
#line 859 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 14:
#line 237 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { (yylhs.value.string) = ""; }
#line 865 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 15:
#line 238 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { std::swap((yylhs.value.string), (yystack_[0].value.string)); }
#line 871 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 16:
#line 243 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    static const sem_type::string_t label{"label"};
    static const sem_type::string_t vcsn_context{"vcsn_context"};
    if ((yystack_[2].value.string) == label)
      std::swap((yylhs.value.string), (yystack_[0].value.string));
    else if ((yystack_[2].value.string) == vcsn_context)
      {
        assert(!driver_.edit_);
        driver_.context_ = (yystack_[0].value.string);
      }
    else
      // Beware of the default "$$ = $1;" action.
      (yylhs.value.string) = "";
  }
#line 890 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 17:
#line 260 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { (yylhs.value.string) = ""; }
#line 896 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 18:
#line 261 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { std::swap((yylhs.value.string), (yystack_[0].value.string)); }
#line 902 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 19:
#line 267 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.string), (yystack_[2].value.string).get().empty() ? (yystack_[0].value.string) : (yystack_[2].value.string));
  }
#line 910 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 24:
#line 284 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {}
#line 916 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 25:
#line 285 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { std::swap((yylhs.value.string), (yystack_[0].value.string)); }
#line 922 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 26:
#line 289 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { (yylhs.value.states).emplace_back(std::move((yystack_[0].value.string))); }
#line 928 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 27:
#line 290 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { (yylhs.value.states) = (yystack_[0].value.states); }
#line 934 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 28:
#line 310 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    for (auto s1: (yystack_[2].value.states))
      for (auto s2: (yystack_[0].value.states))
        (yylhs.value.transitions).emplace_back(s1, s2);
    (yylhs.value.states) = (yystack_[0].value.states);
  }
#line 945 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 29:
#line 317 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.transitions), (yystack_[2].value.transitions));
    for (auto s1: (yystack_[2].value.states))
      for (auto s2: (yystack_[0].value.states))
        (yylhs.value.transitions).emplace_back(s1, s2);
    (yylhs.value.states) = (yystack_[0].value.states);
  }
#line 957 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 30:
#line 328 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    for (auto t: (yystack_[1].value.transitions))
      driver_.edit_->add_entry(t.first, t.second, (yystack_[0].value.string));
  }
#line 966 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 31:
#line 336 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    std::swap((yylhs.value.string), (yystack_[1].value.string));
  }
#line 974 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 32:
#line 343 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {
    // We need the editor to exist.
    TRY(yylhs.location, driver_.setup_());
    std::swap((yylhs.value.string), (yystack_[0].value.string));
    if ((yylhs.value.string).get()[0] == 'I')
      driver_.edit_->add_pre((yylhs.value.string));
    else if ((yylhs.value.string).get()[0] == 'F')
      driver_.edit_->add_post((yylhs.value.string));
    else
      // This is not needed, but it ensures that the states will be
      // numbered by their order of appearance in the file.
      driver_.edit_->add_state((yylhs.value.string));
  }
#line 992 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 33:
//-#line 359 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
//-    { std::swap((yylhs.value.states), (yystack_[1].value.states)); }
//-#line 998 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
//-    break;

  case 34:
#line 360 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { std::swap((yylhs.value.states), (yystack_[1].value.states)); }
#line 1004 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 35:
#line 364 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    {}
#line 1010 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;

  case 36:
#line 365 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:860
    { std::swap((yylhs.value.string), (yystack_[0].value.string)); }
#line 1016 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
    break;


#line 1020 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:860
          default:
            break;
          }
      }
    catch (const syntax_error& yyexc)
      {
        error (yyexc);
        YYERROR;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yylhs);
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    // Shift the result of the reduction.
    yypush_ (YY_NULL, yylhs);
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state,
                                           yyempty ? yyempty_ : yyla.type_get ()));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyempty)
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyempty = true;
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyempty)
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyempty)
          yy_destroy_ (YY_NULL, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULL, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type yystate, symbol_number_type yytoken) const
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULL;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char parser::yypact_ninf_ = -23;

  const signed char parser::yytable_ninf_ = -28;

  const signed char
  parser::yypact_[] =
  {
      26,    16,    23,   -23,    32,   -23,   -23,    -1,    24,    24,
      24,   -23,   -23,    37,    16,    35,   -23,   -23,    38,    28,
     -23,   -23,    29,    39,    40,   -23,   -23,   -23,     4,    41,
      45,   -23,   -23,     6,     6,   -23,   -23,   -23,    37,   -23,
      44,   -23,    43,   -23,   -23,   -23,   -23,   -23,   -23,   -23,
     -23,   -23,    40,    24,    20,   -23,   -23,   -23
  };

  const unsigned char
  parser::yydefact_[] =
  {
       0,    35,     0,    36,     0,     1,     3,     0,     0,     0,
       0,     3,     2,    32,    35,    22,     7,     8,     0,    14,
       6,     5,    14,     9,    24,    12,    10,    11,     0,     0,
       0,    23,     4,     0,     0,    15,    30,    31,    17,    18,
      20,    25,     0,    34,    16,     3,    32,    28,    26,    27,
      29,    21,    24,    14,     0,    19,    13,    33
  };

  const signed char
  parser::yypgoto_[] =
  {
     -23,   -23,   -11,   -23,   -23,     8,   -21,   -22,   -23,   -23,
     -23,   -23,     2,     9,   -23,   -23,   -23,    11,    13,    46
  };

  const signed char
  parser::yydefgoto_[] =
  {
      -1,     2,     7,    15,    16,    35,    36,    17,    40,    41,
      52,    32,    42,    18,    19,    20,    21,    22,    23,     4
  };

  const signed char
  parser::yytable_[] =
  {
      28,    37,    39,     8,     9,    10,    11,    12,     8,     9,
      10,    11,    43,    11,    13,    14,    25,    26,    27,    13,
      14,    46,    14,     5,     8,     9,    10,    11,    57,     1,
      39,     3,    56,    24,    54,    13,    14,    24,    24,     6,
      34,   -26,    47,    50,    48,    48,    49,    49,    29,    31,
      33,   -27,    45,    53,    55,    38,    44,    51,     0,     0,
      30
  };

  const signed char
  parser::yycheck_[] =
  {
      11,    22,    24,     4,     5,     6,     7,     8,     4,     5,
       6,     7,     8,     7,    15,    16,     8,     9,    10,    15,
      16,    15,    16,     0,     4,     5,     6,     7,     8,     3,
      52,    15,    53,     9,    45,    15,    16,     9,     9,     7,
      12,    12,    33,    34,    33,    34,    33,    34,    11,    14,
      12,    12,     7,    10,    52,    15,    15,    13,    -1,    -1,
      14
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,     3,    18,    15,    36,     0,     7,    19,     4,     5,
       6,     7,     8,    15,    16,    20,    21,    24,    30,    31,
      32,    33,    34,    35,     9,    22,    22,    22,    19,    11,
      36,    14,    28,    12,    12,    22,    23,    23,    15,    24,
      25,    26,    29,     8,    15,     7,    15,    30,    34,    35,
      30,    13,    27,    10,    19,    29,    23,     8
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    17,    18,    19,    19,    20,    20,    20,    20,    20,
      21,    21,    21,    22,    23,    23,    24,    25,    25,    26,
      27,    27,    28,    28,    29,    29,    30,    30,    31,    31,
      32,    33,    34,    35,    35,    36,    36
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     5,     0,     3,     1,     1,     1,     1,     1,
       2,     2,     2,     4,     0,     1,     3,     1,     1,     3,
       0,     1,     0,     1,     0,     1,     1,     1,     3,     3,
       2,     2,     1,     5,     3,     0,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "$end", "error", "$undefined", "\"digraph\"", "\"edge\"", "\"graph\"",
  "\"node\"", "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"=\"", "\"->\"",
  "\",\"", "\";\"", "ID", "\"subgraph\"", "$accept", "graph", "stmt_list",
  "stmt", "attr_stmt", "attr_list", "attr_list.opt", "attr_assign", "a",
  "a_list.1", "comma.opt", "semi.opt", "a_list.0", "nodes", "path",
  "edge_stmt", "node_stmt", "node_id", "subgraph", "id.opt", YY_NULL
  };

#if YYDEBUG
  const unsigned short int
  parser::yyrline_[] =
  {
       0,   184,   184,   190,   191,   201,   205,   209,   212,   215,
     222,   223,   224,   228,   237,   238,   242,   260,   261,   266,
     272,   274,   277,   279,   284,   285,   289,   290,   309,   316,
     327,   335,   342,   359,   360,   364,   365
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16
    };
    const unsigned int user_token_number_max_ = 271;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 11 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:1170
} } } // vcsn::detail::dot
#line 1472 "../../lib/vcsn/dot/parse.cc" // lalr1.cc:1170
#line 367 "../../lib/vcsn/dot/parse.yy" // lalr1.cc:1171


namespace vcsn
{
  namespace detail
  {
    namespace dot
    {
      void
      parser::error(const location_type& l, const std::string& m)
      {
        driver_.error(l, m);
      }
    }
  }
}
